<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use App\Http\Providers\iam\core\model\OracleOCIConnector;
use Carbon\Carbon;
use Services\Helper\FileSyncHelper;
use App\Http\Models\StokkapalModel;
use App\Http\Models\LokasiitemModel;

class ItemonhandModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "item_onhand";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "itemonhand";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "ID";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "ID",
        "INVENTORY_ITEM_ID",
        "SEGMENT1",
        "SUBINVENTORY_CODE",
        "ORGANIZATION_ID",
        "ACCT_PERIOD_ID",
        "PERIOD_NAME",
        "PERIOD_START_DATE",
        "SCHEDULE_CLOSE_DATE",
        "QTY",
        "LOT_NUMBER",
        "QTY_AWAL",
        "QTY_MASUK",
        "QTY_KELUAR",
        "CREATION_DATE",
        "LAST_UPDATE_DATE"
    ];


    public function syncFromOracleHO($syncTable)
    {
        echo "start item on hand data from oracle", PHP_EOL;
        (new LogsyncoracleModel)->setLogSync("Master item On-Hand", Carbon::now()->toDateTimeString(), "", "start");
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getOracleQuery($syncTable, 0, 0))->execute();
        $lastUpdate = $syncTable->last_sync;
        while (($rows = $oracleOCI->fetchAll()) !== false) {
            $item = new self();
            $item->storingDataFromOracle($rows);
            if (!empty($rows->LAST_UPDATE_DATE)) $lastUpdate = $rows->LAST_UPDATE_DATE;
            $syncTable = \App\Http\Models\SyncUtilities\StagingSyncTableModel::find($syncTable->id);
            $syncTable->last_sync = $lastUpdate;
            $syncTable->update();
        }
        (new LogsyncoracleModel)->setLogSync("Master item On-Hand", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();
    }


    public static function getOracleQuery($staging, $startRow, $endRow)
    {
        $query = "SELECT  ITEMONHANDV.INVENTORY_ITEM_ID,
                ITEMONHANDV.SEGMENT1,
                ITEMONHANDV.SUBINVENTORY_CODE,
                ITEMONHANDV.ORGANIZATION_ID,
                ITEMONHANDV.LOT_NUMBER,
                ITEMONHANDV.ACCT_PERIOD_ID,
                ITEMONHANDV.PERIOD_NAME,
                ITEMONHANDV.PERIOD_START_DATE,
                ITEMONHANDV.SCHEDULE_CLOSE_DATE,
                ITEMONHANDV.QTY_AWAL,
                ITEMONHANDV.QTY_MASUK,
                ITEMONHANDV.QTY_KELUAR,
                ITEMONHANDV.QTY,
                TO_CHAR(ITEMONHANDV.CREATION_DATE, 'YYYY/MM/DD HH24:MI:SS') AS CREATION_DATE,
                TO_CHAR(ITEMONHANDV.LAST_UPDATE_DATE, 'YYYY/MM/DD HH24:MI:SS') AS LAST_UPDATE_DATE,
                ITEMONHANDV.DATE_UPDATE
                FROM pelni_scm_item_onhand_v ITEMONHANDV 
                WHERE ITEMONHANDV.LAST_UPDATE_DATE >= TO_TIMESTAMP('" . Carbon::parse($staging->last_sync)->toDateTimeString() . "', 'yyyy-mm-dd HH24:MI:SS') 
                AND EXTRACT(MONTH FROM PERIOD_START_DATE) = '" . Carbon::now()->month . "' AND EXTRACT(YEAR FROM PERIOD_START_DATE) ='" . Carbon::now()->year . "' 
                ORDER BY ITEMONHANDV.LAST_UPDATE_DATE ASC";
        return $query;
    }


    public function mapperOracle($oracle)
    {
        $this->INVENTORY_ITEM_ID = $oracle->INVENTORY_ITEM_ID;
        $this->SEGMENT1 = $oracle->SEGMENT1;
        $this->SUBINVENTORY_CODE = $oracle->SUBINVENTORY_CODE;
        $this->ORGANIZATION_ID = $oracle->ORGANIZATION_ID;
        $this->ACCT_PERIOD_ID = $oracle->ACCT_PERIOD_ID;
        $this->PERIOD_NAME = $oracle->PERIOD_NAME;
        $this->PERIOD_START_DATE = $oracle->PERIOD_START_DATE;
        $this->SCHEDULE_CLOSE_DATE = $oracle->SCHEDULE_CLOSE_DATE;
        $this->LOT_NUMBER = $oracle->LOT_NUMBER;
        $this->QTY = ($oracle->QTY > 0) ? $oracle->QTY  : 0;
        $this->QTY_AWAL = ($oracle->QTY_AWAL > 0) ? $oracle->QTY_AWAL : 0;
        $this->QTY_MASUK = ($oracle->QTY_MASUK > 0) ? $oracle->QTY_MASUK : 0;
        $this->QTY_KELUAR = ($oracle->QTY_KELUAR > 0) ? $oracle->QTY_KELUAR : 0;
        $this->CREATION_DATE = $oracle->CREATION_DATE;
        $this->LAST_UPDATE_DATE = $oracle->LAST_UPDATE_DATE;
    }

    public function storingDataFromOracle($oracle)
    {
        $modelExist = new self();
        $modelExist = $modelExist->getQuery()->where("itemonhand.ORGANIZATION_ID", "=", $oracle->ORGANIZATION_ID)
            ->where("itemonhand.INVENTORY_ITEM_ID", "=", $oracle->INVENTORY_ITEM_ID)
            ->where("itemonhand.LOT_NUMBER", "=", $oracle->LOT_NUMBER)
            ->where("itemonhand.SUBINVENTORY_CODE", "=", $oracle->SUBINVENTORY_CODE)
            ->where("itemonhand.SCHEDULE_CLOSE_DATE", "=", $oracle->SCHEDULE_CLOSE_DATE)->first();
        if ($modelExist) {
            try {
                $model = self::find($modelExist->ID);
                $model->mapperOracle($oracle);
                $model->update();
                (new LogsyncoracleModel)->setLogSync("Master item On-Hand - " . $model->SEGMENT1 . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "updated ");
                echo $model->SEGMENT1 . " updated ", PHP_EOL;
                self::storeStockHO($model);
            } catch (\Exception $exception) {
                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Master item On-Hand - " . $model->SEGMENT1 . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed ");
            }
        } else
            try {
                $model = new self();
                $model->mapperOracle($oracle);
                $model->save();
                (new LogsyncoracleModel)->setLogSync("Master item On-Hand - " . $model->SEGMENT1 . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "inserted ");
                echo $model->SEGMENT1 . " inserted ", PHP_EOL;
                self::storeStockHO($model);
            } catch (\Exception $exception) {
                echo $exception->getMessage(), PHP_EOL;
                (new LogsyncoracleModel)->setLogSync("Master item On-Hand - " . $model->SEGMENT1 . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed ");
            }
    }

    public static function getItemOnHand()
    {
        (new LogsynckapalModel)->setLogSync("Item On Hand HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_item_onhand";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 11)->first();
        $fetch = true;
        $page = 1;
        do {
            if ($syncTable) {

                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $lastUpdate = !empty($syncTable->last_sync) ? \Carbon\Carbon::parse($syncTable->last_sync)->toAtomString() : $lastUpdate;
                $url = $url . "?date_updated=" . $lastUpdate . "&kapalId=" . $GLOBALS["env"]["KAPAL_ID"] . "&page=" . $page;
                $syncHandler = new \App\Http\Handler\CurlHandler();
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\ItemonhandModel::storeFromHO($item);
                            \App\Http\Models\ItemonhandModel::storeStockKapal($item);
                            $lastUpdate = $item->LAST_UPDATE_DATE;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else {
                        $fetch = false;
                    }
                } catch (\Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Item On Hand HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Item On Hand HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }

    public static function storeFromHO($data)
    {
        $modelExist = new self();
        $modelExist = $modelExist->getQuery()
            ->where("itemonhand.ORGANIZATION_ID", "=", $data->ORGANIZATION_ID)
            ->where("itemonhand.INVENTORY_ITEM_ID", "=", $data->INVENTORY_ITEM_ID)
            ->where("itemonhand.LOT_NUMBER", "=", $data->LOT_NUMBER)
            ->where("itemonhand.SUBINVENTORY_CODE", "=", $data->SUBINVENTORY_CODE)
            ->where("itemonhand.SCHEDULE_CLOSE_DATE", "=", $data->SCHEDULE_CLOSE_DATE)
            ->first();
        if ($modelExist) {
            try {
                $model = self::find($modelExist->ID);
                $model->INVENTORY_ITEM_ID = $data->INVENTORY_ITEM_ID;
                $model->SEGMENT1 = $data->SEGMENT1;
                $model->SUBINVENTORY_CODE = $data->SUBINVENTORY_CODE;
                $model->ORGANIZATION_ID = $data->ORGANIZATION_ID;
                $model->ACCT_PERIOD_ID = $data->ACCT_PERIOD_ID;
                $model->PERIOD_NAME = $data->PERIOD_NAME;
                $model->PERIOD_START_DATE = $data->PERIOD_START_DATE;
                $model->SCHEDULE_CLOSE_DATE = $data->SCHEDULE_CLOSE_DATE;
                $model->QTY = $data->QTY;
                $model->LOT_NUMBER = $data->LOT_NUMBER;
                $model->QTY_AWAL = $data->QTY_AWAL;
                $model->QTY_MASUK = $data->QTY_MASUK;
                $model->QTY_KELUAR = $data->QTY_KELUAR;
                $model->CREATION_DATE = $data->CREATION_DATE;
                $model->LAST_UPDATE_DATE = $data->LAST_UPDATE_DATE;
                $model->update();
                (new LogsynckapalModel)->setLogSync("Item On Hand HO to Kapal - " . $model->SEGMENT1 . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "updated");
                echo $model->ID . " updated ", PHP_EOL;
                //self::storeStockKapal($model);
            } catch (\Exception $exception) {
                echo $exception->getMessage(), PHP_EOL;
                (new LogsynckapalModel)->setLogSync("Item On Hand HO to Kapal - " . $model->SEGMENT1 . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
            }
        } else
            try {
                $model = new self();
                $model->INVENTORY_ITEM_ID = $data->INVENTORY_ITEM_ID;
                $model->SEGMENT1 = $data->SEGMENT1;
                $model->SUBINVENTORY_CODE = $data->SUBINVENTORY_CODE;
                $model->ORGANIZATION_ID = $data->ORGANIZATION_ID;
                $model->ACCT_PERIOD_ID = $data->ACCT_PERIOD_ID;
                $model->PERIOD_NAME = $data->PERIOD_NAME;
                $model->PERIOD_START_DATE = $data->PERIOD_START_DATE;
                $model->SCHEDULE_CLOSE_DATE = $data->SCHEDULE_CLOSE_DATE;
                $model->QTY = $data->QTY;
                $model->LOT_NUMBER = $data->LOT_NUMBER;
                $model->QTY_AWAL = $data->QTY_AWAL;
                $model->QTY_MASUK = $data->QTY_MASUK;
                $model->QTY_KELUAR = $data->QTY_KELUAR;
                $model->CREATION_DATE = $data->CREATION_DATE;
                $model->LAST_UPDATE_DATE = $data->LAST_UPDATE_DATE;
                $model->save();
                (new LogsynckapalModel)->setLogSync("Item On Hand HO to Kapal - " . $model->SEGMENT1 . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "inserted");
                echo $model->ID . " inserted ", PHP_EOL;
                // self::storeStockKapal($model);
            } catch (\Exception $exception) {
                echo $exception->getMessage(), PHP_EOL;
                (new LogsynckapalModel)->setLogSync("Item On Hand HO to Kapal - " . $model->SEGMENT1 . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
            }
    }

    /**
     * ini untuk storing ke stockkapal
     */
    public static function storeStockKapal($model)
    {
        $isValidUpdateStock = self::validUpdateStock($model); // TO CHECK IF THE ITEM WITH THAT LOT NUMBER IS ALL SYNCED AT ALL TRANSACTIONS
        if ($isValidUpdateStock > 0) {
            (new LogsynckapalModel)->setLogSync("Gagal insert stok kapal, not fully synced " . $isValidUpdateStock . " | " . $model->INVENTORY_ITEM_ID .  " - " . $model->SEGMENT1 . " - " . $model->SUBINVENTORY_CODE . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "failed");
        } else {
            // ini proses inisialiasi object stokkapal
            $lokasiItem = (new LokasiitemModel())->getQuery()->where("lokasiitem.namaLokasi", "=", $model->SUBINVENTORY_CODE)->first();
            //->where("lokasiitem.kapalId","=",$GLOBALS["env"]["KAPAL_ID"])        
            // (new KapallokasiitemModel())->joinRelationLokasiId()->getQuery()->select("kapalLokasiItem.id")
            // ->where("kapalLokasiItem.kapalId", "=", $GLOBALS["env"]["KAPAL_ID"])
            // ->where("lokasiitem.namaLokasi", "=", $model->SUBINVENTORY_CODE)->first();  

            if ($lokasiItem) {

                $stockKapal = new StokkapalModel();
                //$stockKapal->getQuery();
                // melakukan query untuk mencari stock kapal dengan parameter yang dicari
                $stockExist = $stockKapal->getQuery()->where("stokkapal.itemId", "=", $model->INVENTORY_ITEM_ID)
                    ->where("stokkapal.lokasiId", "=", $lokasiItem->id)
                    ->where("stokkapal.kapalId", "=", $GLOBALS["env"]["KAPAL_ID"])
                    ->where("stokkapal.lotNumber", "=", $model->LOT_NUMBER)->first();
                if ($stockExist) {
                    // ini untuk proses update ke stock kapal berdasarkan ID yang sudah di temukan`
                    $updateStock = StokkapalModel::find($stockExist->id);
                    $updateStock->jumlah = $model->QTY;
                    $updateStock->date_updated = $model->LAST_UPDATE_DATE;
                    $updateStock->tglMasuk = $model->CREATION_DATE;
                    $updateStock->lokasiId = $lokasiItem->id;
                    $updateStock->update();
                    (new LogsynckapalModel)->setLogSync("Stock Kapal - " . $model->INVENTORY_ITEM_ID . " - " . $model->SEGMENT1 . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "updated");
                } else {
                    $props["itemId"] = $model->INVENTORY_ITEM_ID;
                    $props["kapalId"] = $model->ORGANIZATION_ID;
                    $props["lokasiId"] = $lokasiItem->id;
                    $props["jumlah"] = $model->QTY;
                    $props["satuan"] = "";
                    $props["status"] = "1";
                    $props["type"] = "1";
                    $props["date_updated"] = $model->LAST_UPDATE_DATE;
                    $props["lotNumber"] = $model->LOT_NUMBER;
                    $props["tglMasuk"] = $model->CREATION_DATE;
                    $createStock = new StokkapalModel($props);
                    $createStock->save();
                    (new LogsynckapalModel)->setLogSync("Stock Kapal - " . $model->INVENTORY_ITEM_ID . " - " . $model->SEGMENT1 . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "inserted");
                }
            } else {
                (new LogsynckapalModel)->setLogSync("Gagal insert stok kapal, tidak ada lokasi " . $model->SUBINVENTORY_CODE, Carbon::now()->toDateTimeString(), "", "failed");
            }
        }
    }

    public static function validUpdateStock($model)
    {
        $nItemNull = 0;
        $nItemNull1 = (new ItempenerimaanbarangioModel)->validUpdateStock($model->INVENTORY_ITEM_ID, $model->LOT_NUMBER);
        $nItemNull2 = (new ItempenggunaanmakananModel)->validUpdateStock($model->INVENTORY_ITEM_ID, $model->LOT_NUMBER);
        $nItemNull3 = (new ItempenerimaanmakananModel)->validUpdateStock($model->INVENTORY_ITEM_ID, $model->LOT_NUMBER);
        $nItemNull4 = (new ItempenggunaanbarangModel)->validUpdateStock($model->INVENTORY_ITEM_ID, $model->LOT_NUMBER);
        $nItemNull5 = (new ItempindahsubinvModel)->validUpdateStock($model->INVENTORY_ITEM_ID, $model->LOT_NUMBER);
        $nItemNull6 = (new ItemtransferioModel)->validUpdateStock($model->INVENTORY_ITEM_ID, $model->LOT_NUMBER);
        $nItemNull7 = (new ItempenerimaanbarangModel)->validUpdateStock($model->INVENTORY_ITEM_ID, $model->LOT_NUMBER);
        $nItemNull8 = (new AdjustmentbbmModel)->validUpdateStock($model->INVENTORY_ITEM_ID, $model->LOT_NUMBER);
        $nItemNull = $nItemNull1 + $nItemNull2 + $nItemNull3 + $nItemNull4 + $nItemNull5 + $nItemNull6 + $nItemNull7 + $nItemNull8;
        if ($nItemNull > 0) {
            return $nItemNull;  // KL ADA YG MASIH BLM SYNCED NILAI NYA > 0
        } else {
            return 0; // KL GA ADA IS_SYNC
        }
    }


    /**
     * Untuk Store STOK HO
     */
    public static function storeStockHO($model)
    {

        $lokasiItem = (new LokasiitemModel())->getQuery()->where("lokasiitem.namaLokasi", "=", $model->SUBINVENTORY_CODE)->first();
        //->where("lokasiitem.kapalId","=",$model->ORGANIZATION_ID)

        if ($lokasiItem) {

            $stockKapal = new StokkapalModel();
            //$stockKapal->getQuery();
            // melakukan query untuk mencari stock kapal dengan parameter yang dicari
            $stockExist = $stockKapal->getQuery()->where("stokkapal.itemId", "=", $model->INVENTORY_ITEM_ID)
                //->where("stokkapal.lokasiId","=",$lokasiItem->id)
                ->where("stokkapal.kapalId", "=", $model->ORGANIZATION_ID)
                ->where("stokkapal.lotNumber", "=", $model->LOT_NUMBER)->first();
            if ($stockExist) {
                // ini untuk proses update ke stock kapal berdasarkan ID yang sudah di temukan`
                $updateStock = StokkapalModel::find($stockExist->id);
                $updateStock->jumlah = $model->QTY;
                $updateStock->date_updated = $model->LAST_UPDATE_DATE;
                $updateStock->tglMasuk = $model->CREATION_DATE;
                $updateStock->lokasiId = $lokasiItem->id;
                $updateStock->update();
                (new LogsyncoracleModel)->setLogSync("Stock ORG_ID " . $model->ORGANIZATION_ID . " - " . $model->INVENTORY_ITEM_ID . " - " . $model->SEGMENT1 . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "updated");
            } else {

                $props["itemId"] = $model->INVENTORY_ITEM_ID;
                $props["kapalId"] = $model->ORGANIZATION_ID;
                $props["lokasiId"] = $lokasiItem->id;
                $props["jumlah"] = $model->QTY;
                $props["satuan"] = "";
                $props["status"] = "1";
                $props["type"] = "1";
                $props["date_updated"] = $model->LAST_UPDATE_DATE;
                $props["lotNumber"] = $model->LOT_NUMBER;
                $props["tglMasuk"] = $model->CREATION_DATE;
                $createStock = new StokkapalModel($props);
                $createStock->save();
                (new LogsyncoracleModel)->setLogSync("Stock ORG_ID " . $model->ORGANIZATION_ID . " - " . $model->INVENTORY_ITEM_ID . " - " . $model->SEGMENT1 . " - " . $model->LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "inserted");
            }
        } else (new LogsyncoracleModel)->setLogSync("Gagal insert stok kapal " . $model->ORGANIZATION_ID . " , tidak ada lokasi " . $model->SUBINVENTORY_CODE, Carbon::now()->toDateTimeString(), "", "failed");
    }
}
